# Uses of Interface
javax.lang.model.element.ModuleElement.Directive

Packages that use ModuleElement.Directive
Package
Description
javax.lang.model.element
Interfaces used to model elements of the Java programming language.
javax.lang.model.util
Utilities to assist in the processing of program elements and types.

## Uses of ModuleElement.Directive in javax.lang.model.element

Subinterfaces of ModuleElement.Directive in javax.lang.model.element
Modifier and Type
Interface
Description
`static interface`
`ModuleElement.ExportsDirective`
An exported package of a module.
`static interface`
`ModuleElement.OpensDirective`
An opened package of a module.
`static interface`
`ModuleElement.ProvidesDirective`
An implementation of a service provided by a module.
`static interface`
`ModuleElement.RequiresDirective`
A dependency of a module.
`static interface`
`ModuleElement.UsesDirective`
A reference to a service used by a module.
Methods in javax.lang.model.element that return ModuleElement.Directive
Modifier and Type
Method
Description
`ModuleElement.Directive`
UnknownDirectiveException.`getUnknownDirective()`
Returns the unknown directive.
Methods in javax.lang.model.element that return types with arguments of type ModuleElement.Directive
Modifier and Type
Method
Description
`List<? extends ModuleElement.Directive>`
ModuleElement.`getDirectives()`
Returns the directives contained in the declaration of this module.
Methods in javax.lang.model.element with parameters of type ModuleElement.Directive
Modifier and Type
Method
Description
`default R`
ModuleElement.DirectiveVisitor.`visit(ModuleElement.Directive d)`
Visits any directive as if by passing itself to that directive's `accept` method and passing `null` for the additional parameter.
`default R`
ModuleElement.DirectiveVisitor.`visit(ModuleElement.Directive d, P p)`
Visits any directive as if by passing itself to that directive's `accept` method.
`default R`
ModuleElement.DirectiveVisitor.`visitUnknown(ModuleElement.Directive d, P p)`
Visits an unknown directive.
Constructors in javax.lang.model.element with parameters of type ModuleElement.Directive
Modifier
Constructor
Description
``
`UnknownDirectiveException(ModuleElement.Directive d, Object p)`
Creates a new `UnknownElementException`.

## Uses of ModuleElement.Directive in javax.lang.model.util

Methods in javax.lang.model.util with parameters of type ModuleElement.Directive
Modifier and Type
Method
Description
`default Elements.Origin`
Elements.`getOrigin(ModuleElement m, ModuleElement.Directive directive)`
Returns the origin of the given module directive.
Method parameters in javax.lang.model.util with type arguments of type ModuleElement.Directive
Modifier and Type
Method
Description
`static List<ModuleElement.ExportsDirective>`
ElementFilter.`exportsIn(Iterable<? extends ModuleElement.Directive> directives)`
Returns a list of `exports` directives in `directives`.
`static List<ModuleElement.OpensDirective>`
ElementFilter.`opensIn(Iterable<? extends ModuleElement.Directive> directives)`
Returns a list of `opens` directives in `directives`.
`static List<ModuleElement.ProvidesDirective>`
ElementFilter.`providesIn(Iterable<? extends ModuleElement.Directive> directives)`
Returns a list of `provides` directives in `directives`.
`static List<ModuleElement.RequiresDirective>`
ElementFilter.`requiresIn(Iterable<? extends ModuleElement.Directive> directives)`
Returns a list of `requires` directives in `directives`.
`static List<ModuleElement.UsesDirective>`
ElementFilter.`usesIn(Iterable<? extends ModuleElement.Directive> directives)`
Returns a list of `uses` directives in `directives`.